/*
 * Handlers for color tags
 *
 */

#include "handlers.h"

#ifdef DEBUG
#include <iostream>

using std::cerr;
#endif

void ColorTag::handle() {
  static unsigned long ignoreclosetag[] = { 0, 0, 0, 0, 0, 0, 0, 0 }; // To eliminate redundant nested tags
  static Prec oldprec[8];
  static int followup[] = { -1, -1, -1, -1, -1, -1, -1, -1 };
  
  if (!closetag) {
    if (nextprec.ulinelevel) {
      // Colors are not valid when ulinelevel = 0
      if (nextprec.color != color) {
        // Set color only when the current context is not of same color
        oldprec[color] = nextprec;
        nextprec.color = color;
        char buf[] = { '<', '\0', '>', '\0' };
        buf[1] = COLORS[color];
        //outstr += buf;
        if (closetagsInTaglist(buf[1])) curtaglist.pop_back();
        else {
          int othercolor = -1;
#if 0
          cerr << "othercolor1 = " << othercolor << '\n';
#endif
          while (closecolortagsInTaglist(othercolor)) {
            unsigned char tmpcolor = color;
            curtaglist.pop_back();
            followup[tmpcolor] = othercolor;
            tmpcolor = othercolor;
          }
#if 0
          cerr << "othercolor2 = " << othercolor << '\n';
#endif
          curtaglist.push_back(buf);
        }
      }
    } else ignoreclosetag[color]++; // Remember to ignore corresponding close tag
  } else {
    if (ignoreclosetag[color]) ignoreclosetag[color]--;
    else {
      nextprec = oldprec[color];
      char buf[] = { '<', '/', '\0', '>', '\0' };
      buf[2] = COLORS[color];
      //outstr += buf;
      if (opentagsInTaglist()) curtaglist.pop_back();
      else curtaglist.push_back(buf);
      unsigned char col = color;
      while (followup[col] >= 0) {
        unsigned char tmpcol = followup[col];
        char buf1[] = { '<', '/', '\0', '>', '\0' };
        buf1[2] = COLORS[tmpcol];
        curtaglist.push_back(buf1);
        followup[col] = -1;
        col = tmpcol;
      }
    }
  }
}
