/* -*-c++-*- */

/*
 * Declarations for SML/NG contexts
 *
 */

struct Prec {
  bool isbold;
  bool isemph;
  bool isital;
  bool isstrg;
  bool isttype;
  unsigned char ulinelevel;
  unsigned char size;
  unsigned char color;

  // Initialize size and color with impossible values to be safe
  Prec() : isbold(false), isemph(false), isital(false), isstrg(false), isttype(false),
           ulinelevel(0), size(10), color(10) { }
  bool operator==(const Prec&) const;
  bool isPlain() const {
    return !(isbold || isital || isemph || isstrg || isttype || ulinelevel);
  }
}; /* End of struct Prec */

struct Wsprec {
  bool isttype;
  unsigned char ulinelevel;
  unsigned char size;
  unsigned char color;

  // Initialize size and color with impossible values to be safe
  Wsprec() : isttype(false), ulinelevel(0), size(10), color(10) { }
  Wsprec(const Prec& pr) : isttype(pr.isttype),
                           ulinelevel(pr.ulinelevel),
                           size(pr.size),
                           color(pr.color) { }
  bool operator==(const Wsprec&) const;
}; /* End of struct Wsprec */

extern Prec nextprec;
/*extern bool validnextprec;*/
extern Wsprec lastwsprec;
extern bool validlastwsprec;
