/* -*-c++-*- */

#include "smlng.h"
#include "context.h"

#include <algorithm>

using std::find;

#ifdef DEBUG
#include <iostream>

using std::cerr;
#endif

// Shared global data between the handlers
extern crope outstr;
extern unsigned long numoutchars;
extern char lastoutputchar;
extern list<string> curtaglist;
extern bool skipnextem;

inline bool opentagsInTaglist() {
  if (curtaglist.empty()) return false;
  list<string>::iterator li = curtaglist.end();
  --li;
  return ((*li)[1] != '/');
}

inline bool closetagsInTaglist(char c) {
  if (curtaglist.empty()) return false;
  list<string>::iterator li = curtaglist.end();
  --li;
  return ( ((*li)[1] == '/') && ((*li)[2] == c) );
}

inline bool closecolortagsInTaglist(int& oc) {
  if (curtaglist.empty()) return false;
  list<string>::iterator li = curtaglist.end();
  --li;
  if ( (*li)[1] != '/' ) return false;
  const char* pos = find(COLORS, COLORS+8, (*li)[2]);
  oc = pos - COLORS;
  if ((oc < 0) || (oc > 7)) return false;
  return true;
}

inline bool closesizetagsInTaglist(int& os) {
  if (curtaglist.empty()) return false;
  list<string>::iterator li = curtaglist.end();
  --li;
  if ( (*li)[1] != '/' ) return false;
  os = (*li)[2] - '0';
  if ((os < 0) || (os > 9)) return false;
  return true;
}
