/*
 * Handlers for size tags
 *
 */

#include "handlers.h"

void SizeTag::handle() {
  static unsigned long ignoreclosetag[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }; // To eliminate redundant nested tags
  static Prec oldprec[10];
  static int followup[] = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };
  
  if (!closetag) {
    if (nextprec.size != size) {
      // Set size only if it is not the same as in present context
      oldprec[size] = nextprec;
      nextprec.size = size;
      char buf[] = {'<', '\0', '>','\0' };
      buf[1] = (char) (size+'0');
      //outstr += buf;
      if (closetagsInTaglist(buf[1])) curtaglist.pop_back();
      else {
        int othersz = -1;
        while (closesizetagsInTaglist(othersz)) {
          unsigned char tmpsz = size;
          curtaglist.pop_back();
          followup[tmpsz] = othersz;
          tmpsz = othersz;
        }
        curtaglist.push_back(buf);
      }
    } else ignoreclosetag[size]++; // if redundant remember to ignore the corresponding close tag
  } else {
    if (ignoreclosetag[size]) ignoreclosetag[size]--;
    else {
      nextprec = oldprec[size];
      char buf[] = { '<', '/', '\0', '>', '\0' };
      buf[2] = (char) (size + '0');
      //outstr += buf;
      if (opentagsInTaglist()) curtaglist.pop_back();
      else curtaglist.push_back(buf);
      unsigned char sz = size;
      while (followup[sz] >= 0) {
        unsigned char tmpsz = followup[sz];
        char buf1[] = { '<', '/', '\0', '>', '\0' };
        buf1[2] = (char)(tmpsz + '0');
        curtaglist.push_back(buf1);
        followup[sz] = -1;
        sz = tmpsz;
      }
    }
  }
}
