/*
 * Handler routine for white space
 *
 */

#include "handlers.h"

void Ws::handle() {
  // Implement ws compression
  Wsprec wspr = nextprec;
  if (!wspr.isttype && validlastwsprec && ((lastoutputchar == SPC) && (lastwsprec == wspr))) return;
  
  if (!curtaglist.empty()) {
    int numtags = curtaglist.size();
    for (int i=0; i < numtags; i++) {
      string buf = curtaglist.front();
      outstr += buf.c_str();
      curtaglist.pop_front();
    }
    skipnextem = false;
  }
  
  if (wspr.isttype) {
    lastoutputchar = wschar;
    outstr += wschar;
    lastwsprec = wspr;
    validlastwsprec = true;
    return;
  }
  if (!validlastwsprec) {
    lastoutputchar = SPC;
    lastwsprec = wspr;
    validlastwsprec = true;
    outstr += SPC;
    return;
  }
  if ( !((lastoutputchar == SPC) && (lastwsprec == wspr)) ) {
    lastoutputchar = SPC;
    lastwsprec = wspr;
    outstr += SPC;
    return;
  }
}
